# virt.instance.device_list

List all devices associated to an instance.

Type: object

##

Type: array
No Additional Items

#### Tuple Validation

##### Parameter 1: id

#### id

Type: string

ID of the virtual instance to list devices for.

##

#### Result

Type: array

Array of devices attached to the virtual instance.

No Additional Items

##### Each item of this array must be:

## One of

#### Disk

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for virtual disk devices.

Specific value: `"DISK"`

##

#### Source

Default: null

For CONTAINER instances, this would be a valid pool path. For VM instances, it can be a valid zvol path or an incus storage volume name.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Destination

Default: null

Target path where the disk appears inside the virtualized instance.

## Any of

Type: string
Type: null

##

#### Boot Priority

Default: null

Boot priority for this disk device. Lower numbers boot first. `null` means non-bootable.

## Any of

Type: integer

Value must be greater or equal to `0`

Type: null

##

#### Io Bus

Type: enum (of null or string) Default: null

Storage bus type for optimal performance and compatibility.

##### Must be one of:

- "NVME"
- "VIRTIO-BLK"
- "VIRTIO-SCSI"
- null

##

#### Storage Pool

Default: null

Storage pool in which the device is located. This must be one of the storage pools listed in virt.global.config output.
If this is set to None during device creation, then the default storage pool defined in virt.global.config will be used.

## Any of

Type: string

Must be at least `1` characters long

Type: null

#### GPU

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for graphics processing units.

Specific value: `"GPU"`

##

#### Gpu Type

Type: enum (of string)

Type of GPU virtualization (physical passthrough, mediated device, etc.).

##### Must be one of:

- "PHYSICAL"
- "MDEV"
- "MIG"
- "SRIOV"

##

#### Id

Default: null

Unique identifier for the GPU device.

## Any of

Type: string
Type: null

##

#### Gid

Default: null

Group ID for device permissions inside the container.

## Any of

Type: integer

Value must be greater or equal to `0` and lesser or equal to `90000000`

Type: null

##

#### Uid

Default: null

User ID for device permissions inside the container.

## Any of

Type: integer

Value must be greater or equal to `0` and lesser or equal to `90000000`

Type: null

##

#### Mode

Default: null

Permission mode for device access (e.g., '660').

## Any of

Type: string
Type: null

##

#### Mdev

Default: null

Mediated device identifier for GPU virtualization.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Mig Uuid

Default: null

Multi-Instance GPU UUID for NVIDIA GPU partitioning.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Pci

Default: null

PCI address of the GPU device on the host system.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Productid

Default: null

Product identifier for GPU device matching.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Vendorid

Default: null

Vendor identifier for GPU device matching.

## Any of

Type: string

Must be at least `1` characters long

Type: null

#### Proxy

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for network port forwarding.

Specific value: `"PROXY"`

##

#### Source Proto

Type: enum (of string)

Network protocol (TCP or UDP) for the source connection.

##### Must be one of:

- "UDP"
- "TCP"

##

#### Source Port

Type: integer

Source port number on the host system to forward from.

Value must be greater or equal to `1` and lesser or equal to `65535`

##

#### Dest Proto

Type: enum (of string)

Network protocol (TCP or UDP) for the destination connection.

##### Must be one of:

- "UDP"
- "TCP"

##

#### Dest Port

Type: integer

Destination port number inside the virtualized instance.

Value must be greater or equal to `1` and lesser or equal to `65535`

#### TPM

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for Trusted Platform Module devices.

Specific value: `"TPM"`

##

#### Path

Default: null

Path to the TPM device on the host system.

## Any of

Type: string
Type: null

##

#### Pathrm

Default: null

Resource manager path for TPM device access.

## Any of

Type: string
Type: null

#### USB

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for USB devices.

Specific value: `"USB"`

##

#### Bus

Default: null

USB bus number on the host system.

## Any of

Type: integer
Type: null

##

#### Dev

Default: null

USB device number on the specified bus.

## Any of

Type: integer
Type: null

##

#### Product Id

Default: null

USB product identifier for device matching.

## Any of

Type: string
Type: null

##

#### Vendor Id

Default: null

USB vendor identifier for device matching.

## Any of

Type: string
Type: null

#### NIC

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for network interface cards.

Specific value: `"NIC"`

##

#### Network

Default: null

Name of the network to connect this NIC to.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Nic Type

Default: null

Type of network interface (bridged or macvlan).

## Any of

Type: enum (of string)

##### Must be one of:

- "BRIDGED"
- "MACVLAN"

Type: null

##

#### Parent

Default: null

Parent network interface on the host system.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Mac

Default: null

MAC address for the virtual network interface. `null` for auto-generated.

## Any of

Type: string
Type: null

#### PCI

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for PCI device passthrough.

Specific value: `"PCI"`

##

#### Address

Type: string

PCI bus address of the device to pass through to the virtualized instance.

Must be at least `1` characters long

#### CDROM

Type: object
No Additional Properties

##

#### Name

Default: null

Optional human-readable name for the virtualization device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Description

Default: null

Optional description explaining the purpose or configuration of this device.

## Any of

Type: string

Must be at least `1` characters long

Type: null

##

#### Readonly

Type: boolean Default: false

Whether the device should be mounted in read-only mode.

##

#### Dev Type

Type: const

Device type identifier for CD-ROM/DVD optical drives.

Specific value: `"CDROM"`

##

#### Source

Type: string

Path to the ISO image file or physical optical drive to mount.

Must be at least `1` characters long

##

#### Boot Priority

Default: null

Boot priority for this optical device. Lower numbers boot first. `null` means non-bootable.

## Any of

Type: integer

Value must be greater or equal to `0`

Type: null

Required roles: VIRT_INSTANCE_READ